//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BitmapQuestion.h"

#include "VCLTee.TeExport.hpp"
#include "VCLTee.TeePDFCanvas.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm3 *Form3;
//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
	: TForm(Owner)
{
	Series1->Clear();
	int pos = Series1->AddXY(0,0);
	pos = Series1->AddXY(100,100);

	showLines = false;
	for (int i=0; i < maxNumLines; i++) {
		xPoints[i] = rand()*100/RAND_MAX;
		yPoints[i] = rand()*100/RAND_MAX;
	}
	linesToDraw = ComboBox1->Text.ToDouble();
	showLines = true;

}
//---------------------------------------------------------------------------
void __fastcall TForm3::Chart1BeforeDrawSeries(TObject *Sender)
{
	Stopwatch = TStopwatch::StartNew();
	Label2->Caption = "Drawing...";
	Application->ProcessMessages();

	if (backInvalid) {
		backChart = new TBitmap();
		backChart->Transparent = true;
        backChart->Canvas->Pen->Color = clGray;
		backChart->SetSize(Chart1->ChartRect.Width(), Chart1->ChartRect.Height());
		for (int i=0; i < linesToDraw; i++) {
			int xmid = Series1->CalcXPosValue(0)-Chart1->ChartRect.Left;
			int ymid = Series1->CalcYPosValue(0)-Chart1->ChartRect.Top;
			backChart->Canvas->MoveTo(xmid,ymid);
			//Chart1->Canvas->MoveTo(xmid,ymid);
			xmid = Series1->CalcXPosValue(xPoints[i])-Chart1->ChartRect.Left;
			ymid = Series1->CalcYPosValue(yPoints[i])-Chart1->ChartRect.Top;
			backChart->Canvas->LineTo(xmid,ymid);
			//Chart1->Canvas->LineTo(xmid,ymid);
		}
		backInvalid = false;
	}
	if (backChart != NULL) {
		Chart1->Canvas->Draw(Chart1->ChartRect.Left, Chart1->ChartRect.Top, backChart);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm3::Chart1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y)
{
	if (Shift.Contains(ssShift)) {
		Series1->XValues->Value[1] = Series1->XScreenToValue(X);
		Series1->YValues->Value[1] = Series1->YScreenToValue(Y);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ComboBox1Change(TObject *Sender)
{
	linesToDraw = ComboBox1->Text.ToDouble();
	backInvalid = true;
	Chart1->Draw();
}
//---------------------------------------------------------------------------
void __fastcall TForm3::Button1Click(TObject *Sender)
{
	SaveDialog1->Filter = "Adobe PDF file (*.pdf)|*.pdf";
	SaveDialog1->DefaultExt = "pdf";
	if (SaveDialog1->Execute()) {
		TeeSaveToPDFFile(Chart1,SaveDialog1->FileName);
	}

}
//---------------------------------------------------------------------------
void __fastcall TForm3::Chart1AfterDraw(TObject *Sender)
{
	Stopwatch.Stop();
	TTimeSpan Timespan = Stopwatch.Elapsed;
	Label2->Caption = String(Timespan.Seconds)+" seconds, " + String(Timespan.Milliseconds)+" milliseconds.";
}
//---------------------------------------------------------------------------

